## pwru 1.0.5+ds1

=== Makefile ===
GO := go
GO_BUILD = CGO_ENABLED=1 $(GO) build
GO_GENERATE = $(GO) generate
GO_TAGS ?=
TARGET_GOARCH ?= amd64
GOARCH ?= amd64
TARGET=pwru
INSTALL = $(QUIET)install
BINDIR ?= /usr/local/bin
VERSION=$(shell git describe --tags --always)
LIBPCAP_ARCH ?= x86_64-unknown-linux-gnu
# For compiling libpcap and CGO
CC ?= gcc

TEST_TIMEOUT ?= 5s
.DEFAULT_GOAL := pwru

## Build the GO binary
pwru: libpcap/libpcap.a
	TARGET_GOARCH=$(TARGET_GOARCH) $(GO_GENERATE)
	CC=$(CC) GOARCH=$(TARGET_GOARCH) $(GO_BUILD) $(if $(GO_TAGS),-tags $(GO_TAGS)) \
		-ldflags "-w -s \
		-X 'github.com/cilium/pwru/internal/pwru.Version=${VERSION}'"

## Build libpcap for static linking
libpcap/libpcap.a:
	cd libpcap && \
		CC=$(LIBPCAP_CC) ./configure --disable-rdma --disable-shared --disable-usb --disable-netmap --disable-bluetooth --disable-dbus --without-libnl --host=$(LIBPCAP_ARCH) && \
		make

## Build the GO binary within a Docker container
release:
	docker run \
		--rm \
		--workdir /pwru \
		--volume `pwd`:/pwru docker.io/library/golang:1.20.5 \
		sh -c "apt update && apt install -y make git clang-15 llvm curl gcc flex bison gcc-aarch64* libc6-dev-arm64-cross && \
			ln -s /usr/bin/clang-15 /usr/bin/clang && \
			git config --global --add safe.directory /pwru && \
			make local-release"

## Build a new release
local-release: clean
	ARCHS='amd64 arm64' ./local-release.sh

## Install the GO Binary to the location specified by 'BINDIR'
install: $(TARGET)
	$(INSTALL) -m 0755 -d $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 0755 $(TARGET) $(DESTDIR)$(BINDIR)

## Clean up build artifacts
clean:
	rm -f $(TARGET)
	rm -f kprobepwru_bpf*
	rm -f kprobemultipwru_bpf*
	rm -f kprobepwruwithoutoutputskb_bpf*
	rm -f kprobemultipwruwithoutoutputskb_bpf*
	cd libpcap/ && make clean || true

## Run GO tests
test:
	$(GO) test -timeout=$(TEST_TIMEOUT) -race -cover $$($(GO) list ./...)

# COLORS
GREEN  := $(shell tput -Txterm setaf 2)
YELLOW := $(shell tput -Txterm setaf 3)
WHITE  := $(shell tput -Txterm setaf 7)
RESET  := $(shell tput -Txterm sgr0)

TARGET_MAX_CHAR_NUM=20
## Show this help
help:
	@echo ''
	@echo 'Usage:'
	@echo '  ${YELLOW}make${RESET} ${GREEN}<target>${RESET}'
	@echo ''
	@echo 'Targets:'

	@awk '/^[a-zA-Z0-9_-]+:/ { \
		helpMessage = match(lastLine, /^## (.*)/); \
		if (helpMessage) { \
			helpCommand = substr($$1, 0, index($$1, ":")-1); \
			helpMessage = substr(lastLine, RSTART + 3, RLENGTH); \
			printf "  ${YELLOW}%-$(TARGET_MAX_CHAR_NUM)s${RESET} ${GREEN}%s${RESET}\n", helpCommand, helpMessage; \
		} \
	} \
	{ lastLine = $$0 }' $(MAKEFILE_LIST)

.PHONY: $(TARGET) release local-release install clean test

=== debian/changelog ===
pwru (1.0.5+ds1-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fixup FTBFS with new cilium-ebpf (Closes: #1115955)
  * Tighten B-D on cilium-ebpf
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Drop redundant "Rules-Requires-Root: no"

 -- Nilesh Patra <nilesh@debian.org>  Sun, 19 Oct 2025 12:36:09 +0530

pwru (1.0.5+ds1-1) unstable; urgency=medium

  * Initial release (Closes: #1063031)

 -- Loren M. Lang <lorenl@north-winds.org>  Tue, 14 Jan 2025 20:54:07 -0800

=== debian/control ===
Source: pwru
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Loren M. Lang <lorenl@north-winds.org>,
Build-Depends:
 debhelper-compat (= 13),
 clang,
 dh-sequence-golang,
 golang-any,
 golang-github-cheggaaa-pb.v3-dev (>= 3.1.4),
 golang-github-cilium-ebpf-dev (>= 0.17.3),
 golang-github-cloudflare-cbpfc-dev (>= 0.0~git20221018),
 golang-github-jsimonetti-rtnetlink-dev (>= 1.4.0),
 golang-github-mitchellh-go-ps-dev (>= 0.0~git20150710.0.e6c6068),
 golang-github-spf13-pflag-dev (>= 1.0.5),
 golang-github-vishvananda-netns-dev (>= 0.0.4),
 golang-golang-x-net-dev (>= 1:0.19.0),
 golang-golang-x-sys-dev (>= 0.15.0),
 libpcap0.8-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/pwru
Vcs-Git: https://salsa.debian.org/go-team/packages/pwru.git
Homepage: https://github.com/cilium/pwru
XS-Go-Import-Path: github.com/cilium/pwru

Package: pwru
Section: net
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: eBPF-based Linux kernel networking debugger (program)
 pwru is an eBPF (https://ebpf.io)-based tool for tracing network packets
 in the Linux kernel with advanced filtering capabilities. It allows fine-
 grained introspection of kernel state to facilitate debugging network
 connectivity issues.
 .
 pwru requires >= 5.3 kernel to run. debugfs has to be mounted in
 /sys/kernel/debug.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE := 1
export DH_GOLANG_GO_GENERATE := 1
export TARGET_GOARCH := $(subst ppc64el,ppc64le,$(subst armel,arm,$(subst armhf,arm,$(subst i386,386,$(shell dpkg-architecture -q DEB_HOST_ARCH)))))

%:
	dh $@ --builddirectory=debian/build --buildsystem=golang

override_dh_auto_install:
	dh_auto_install -- --no-source
